"use strict";

var _getMetaTagsMarkup = _interopRequireDefault(require("./getMetaTagsMarkup.js"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
describe('getMetaTagsMarkup', function () {
  it("should generate meta tags markup", function () {
    (0, _getMetaTagsMarkup["default"])({
      charset: 'utf-8',
      title: 'Test',
      description: 'Testing metadata',
      locale: 'ru',
      locales: ['en', 'fr'],
      viewport: 'width=device-width, initial-scale=1',
      keywords: 'react, redux, webpack',
      author: '@catamphetamine'
    }).should.deep.equal(["<meta charset=\"utf-8\"/>", "<title>Test</title>", "<meta property=\"og:title\" content=\"Test\"/>", "<meta name=\"description\" content=\"Testing metadata\"/>", "<meta property=\"og:description\" content=\"Testing metadata\"/>", "<meta property=\"og:locale\" content=\"ru\"/>", "<meta property=\"og:locale:alternate\" content=\"en\"/>", "<meta property=\"og:locale:alternate\" content=\"fr\"/>", "<meta name=\"viewport\" content=\"width=device-width, initial-scale=1\"/>", "<meta name=\"keywords\" content=\"react, redux, webpack\"/>", "<meta name=\"author\" content=\"@catamphetamine\"/>"]);
  });
  it("should generate meta tags markup with default title and charset", function () {
    (0, _getMetaTagsMarkup["default"])({}).should.deep.equal(["<meta charset=\"utf-8\"/>", "<title></title>"]);
  });
});
//# sourceMappingURL=getMetaTagsMarkup.test.js.map