"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = createHttpClient;
var _HttpClient = _interopRequireDefault(require("../HttpClient.js"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function createHttpClient(settings, getStore) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  // Add `useSelector()` parameter to `http.onRequest()` function.
  var onBeforeSend;
  if (settings.http.onRequest) {
    onBeforeSend = function onBeforeSend(request, parameters) {
      settings.http.onRequest(request, _objectSpread(_objectSpread({}, parameters), {}, {
        useSelector: function useSelector(getter) {
          return getter(getStore().getState());
        }
      }));
    };
  }
  var _ref = settings.http.authentication || {},
    accessToken = _ref.accessToken,
    authTokenHeader = _ref.header;

  // Add `useSelector()` parameter to `accessToken()` function.
  var getAuthToken;
  if (accessToken) {
    getAuthToken = function getAuthToken(getCookie, helpers) {
      // If a token is returned from this function, it gets sent as
      // `Authorization: Bearer {token}` HTTP header.
      return accessToken(_objectSpread(_objectSpread({}, helpers), {}, {
        getCookie: getCookie,
        useSelector: function useSelector(getter) {
          return getter(getStore().getState());
        }
      }));
    };
  }
  return new _HttpClient["default"](_objectSpread({
    onBeforeSend: onBeforeSend,
    getAuthToken: getAuthToken,
    authTokenHeader: authTokenHeader,
    catchToRetry: settings.http["catch"],
    transformUrl: settings.http.transformUrl,
    parseDates: settings.http.findAndConvertIsoDateStringsToDateInstances,
    useCrossDomainCookies: settings.http.useCrossDomainCookies
  }, options));
}
//# sourceMappingURL=HttpClient.js.map