"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = render;
var _index = require("../../router/index.js");
var _createRouterElement = _interopRequireDefault(require("../../router/client/createRouterElement.js"));
var _flags = require("../../client/flags.js");
var _hotReload = require("../hotReload.js");
var _context = require("../../context.js");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
// Renders the current page React element inside the `to` DOM element.
//
// Returns a `Promise` resolving to `{ store, component }`,
// where `component` is the rendered React component
// and `store` is the Redux store.
//
function render(_ref) {
  var store = _ref.store;
  return (0, _index.matchRoutes)(store).then(function (renderArgs) {
    // The first pass of initial client-side render
    // was to render the markup which matches server-side one.
    // The second pass is about rendering after resolving `getData`.
    (0, _context.clearInContext)('InitialPage/RepeatingServerSideRenderOnClientSide');
    (0, _context.clearInContext)('InitialPage/SkipLoad');

    // // `routes` are used when comparing `instantBack` chain items
    // // for resetting `instantBack` chain when the same route is encountered twice.
    // setInContext('...RouteComponents..., renderArgs.routeIndices)

    return {
      element: (0, _createRouterElement["default"])(renderArgs, store),
      rootComponentProps: {
        store: store
      },
      // The rest of the properties here will be available for a developer in the `result` object
      // returned from the client-side `render()` function.

      // Redux `store` could be used to "hot-reload" reducers via Webpack Hot Module Replacement.
      enableHotReload: function enableHotReload() {
        return (0, _hotReload.startHotReload)({
          store: store
        });
      }
    };
  });
}
//# sourceMappingURL=render.js.map