"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.startHotReload = startHotReload;
exports.updateReducers = updateReducers;
var ReduxHotReloadFunction;
var ReduxHotReloadFunctionDelayedRunArgument;
function startHotReload(_ref) {
  var store = _ref.store;
  if (typeof window === 'undefined') {
    throw new Error('[react-pages] "hot reload" only works in a web browser');
  }
  // Updates Redux "reducers" and actions.
  ReduxHotReloadFunction = function ReduxHotReloadFunction(_ref2) {
    var reducers = _ref2.reducers;
    // `store.hotReload()` function is created in `./lib/redux/store.js`.
    store.hotReload(reducers);
  };
  // If if a hot reload has been requested before the page finished rendering.
  if (ReduxHotReloadFunctionDelayedRunArgument) {
    ReduxHotReloadFunction(ReduxHotReloadFunctionDelayedRunArgument);
    ReduxHotReloadFunctionDelayedRunArgument = undefined;
  }
}
function updateReducers(reducers) {
  if (typeof window === 'undefined') {
    throw new Error('[react-pages] `reducers` could only be updated in a web browser');
  }
  if (ReduxHotReloadFunction) {
    ReduxHotReloadFunction({
      reducers: reducers
    });
  } else {
    ReduxHotReloadFunctionDelayedRunArgument = {
      reducers: reducers
    };
  }
}
//# sourceMappingURL=hotReload.js.map