"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = useRefreshMeta;
var _reactRedux = require("react-redux");
var _actions = require("./actions.js");
// Recalculates the current page's metadata.
//
// Acadeum Course Share website uses this hook because it patches
// the page `Component`'s `.meta()` function in real time based on
// whether the user is authenticated or not.
//
function useRefreshMeta() {
  var dispatch = (0, _reactRedux.useDispatch)();
  return function refreshMeta() {
    dispatch({
      type: _actions.REFRESH_META
    });
  };
}
//# sourceMappingURL=useRefreshMeta.js.map