"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = useSelectorForLocation;
var _react = require("react");
var _reactRedux = require("react-redux");
var _useNavigationLocation = _interopRequireDefault(require("./navigation/useNavigationLocation.js"));
var _useLocation = _interopRequireDefault(require("../router/useLocation.js"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function useSelectorForLocation(selector) {
  var location = (0, _useLocation["default"])();
  var navigationLocation = (0, _useNavigationLocation["default"])();
  var value = (0, _reactRedux.useSelector)(selector);
  var latestValueForThisLocation = (0, _react.useRef)();
  if (location.pathname === navigationLocation.pathname) {
    latestValueForThisLocation.current = value;
  }
  return latestValueForThisLocation.current;
}
//# sourceMappingURL=useSelectorForLocation.js.map