"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = createHistoryProtocol;
var _farce = require("@catamphetamine/farce");
// `@catamphetamine/farce` is a fork of `farce` with some changes:
// * `redux` is in `peerDependencies` instead of `dependencies`.
// * Added additional properties in a `location` (`BrowserProtocol`/`ServerProtocol`):
//   * `origin`
//   * `hostname`
//   * `host`
//   * `port`
//   * `protocol`
// * `ServerProtocol` has a different constructor argument: `{ url, origin }` instead of `url`.

function createHistoryProtocol(_ref) {
  var url = _ref.url,
    origin = _ref.origin;
  return new _farce.ServerProtocol({
    url: url,
    origin: origin
  });
}
//# sourceMappingURL=createHistoryProtocol.js.map