"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = useGoForward;
var _react = require("react");
var _useLocationHistory = _interopRequireDefault(require("./useLocationHistory.js"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function useGoForward(delta) {
  var locationHistory = (0, _useLocationHistory["default"])();
  var goForward = (0, _react.useCallback)(function () {
    var delta = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
    if (delta < 1) {
      throw new Error('`delta` argument can\'t be less than `1`');
    }
    locationHistory.go(delta);
  }, [locationHistory]);
  return goForward;
}
//# sourceMappingURL=useGoForward.js.map