"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = useLocationHistory;
var _react = require("react");
var _reactRedux = require("react-redux");
var _actions = require("./actions.js");
// Returns a `locationHistory` object:
//
// * `locationHistory.push(location)`
// * `locationHistory.replace(location)`
// * `locationHistory.go(delta)`
//
function useLocationHistory() {
  var dispatch = (0, _reactRedux.useDispatch)();
  var push = (0, _react.useCallback)(function (location) {
    dispatch((0, _actions.pushLocation)(location));
  }, [dispatch]);
  var replace = (0, _react.useCallback)(function (location) {
    dispatch((0, _actions.replaceLocation)(location));
  }, [dispatch]);
  var go = (0, _react.useCallback)(function (delta) {
    dispatch((0, _actions.navigateThroughHistory)(delta));
  }, [dispatch]);
  return (0, _react.useMemo)(function () {
    return {
      push: push,
      replace: replace,
      go: go
    };
  }, [push, replace, go]);
}
//# sourceMappingURL=useLocationHistory.js.map